#ifndef CMAIN_H
#define CMAIN_H

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/neutrino.h>
#include <inttypes.h>

/* Local headers */
#include "ablibs.h"
#include "abimport.h"
#include "proto.h"
#include "tga.h"
#include "gui.h"
#include "creceivethread.h"

class CMain
{
 protected:
  //-Переменные класса-------------------------------------------------------
  unsigned char *VPtr;//указатель на буфер выводимого изображения
  unsigned char *ColorImage;//указатель на буфер хранимого раскрашенного изображения
  unsigned short *ThermalImage;//указатель на буфер хранимого теплового изображения
  CReceiveThread cReceiveThread;//класс получения данных от Flir One
  bool SaveAllFrame;//сохранять ли все кадры
  unsigned long LastSavedFrameIndex;//индекс последнего сохранённого изображения
  //-Функции класса----------------------------------------------------------
  //-Прочее------------------------------------------------------------------
 public:
  //-Конструктор класса------------------------------------------------------
  CMain();
  //-Деструктор класса-------------------------------------------------------
  ~CMain();
  //-Переменные класса-------------------------------------------------------
  //-Замещённые функции предка-----------------------------------------------
  //-Новые функции класса----------------------------------------------------
 public:  
  bool OnOpening(void);//открытие окна
  bool OnClosing(void);//закрытие окна
  void Redraw(void);//отрисовать картинку
  void OnTimer(void);//обработка таймера    
  //-Функции обработки сообщений класса--------------------------------------
  void OnButton_SaveAllFrame(void);//сохранять все кадры
  void OnButton_SaveCurrentFrame(void);//сохранить текущий кадр
  //-Новые функции класса----------------------------------------------------
  //-Прочее------------------------------------------------------------------
 protected:
  void SaveColorImage(void);//сохранить раскрашенное изображение
  void SaveThermalImage(void);//сохранить тепловое изображение
};

#endif